local Assets=
{
	Asset("ANIM", "anim/book_norman.zip"),
		
	Asset("IMAGE", "images/inventoryimages/book_agetha.tex"),	
    Asset("ATLAS", "images/inventoryimages/book_agetha.xml")
}

function ghostfn(inst, reader)
    reader.components.sanity:DoDelta(-TUNING.SANITY_SMALL)
    local range = 50
    local pos = Vector3(reader.Transform:GetWorldPosition())
    local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, range)
    for k,v in pairs(ents) do
        if v:HasTag("ghost") and v ~= reader then
            v.components.health:SetVal(0)
			if v:HasTag("agetha") or v:HasTag("abigail") then
				 reader.components.sanity:DoDelta(-TUNING.SANITY_SMALL*2)
			else
				reader.components.sanity:DoDelta(-TUNING.SANITY_SMALL/2)
			end
        end
    end
    return true
end

local function fn(Sim)
	
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()
    anim:SetBank("books")
    anim:SetBuild("book_norman")
	
	anim:PlayAnimation("book_brimstone")
    MakeInventoryPhysics(inst)
	
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/book_agetha.xml"
	-----------------------------------
	
	inst:AddComponent("inspectable")
    inst:AddComponent("book")
    inst.components.book.onread = ghostfn

	MakeSmallBurnable(inst)
	MakeSmallPropagator(inst)
	
	inst:AddTag("irreplaceable")
	
	return inst

end

return Prefab( "common/inventory/book_agetha", fn, Assets)