local assets =
{
	Asset("ANIM", "anim/ghost.zip"),
	Asset("ANIM", "anim/ghost_build.zip"),
	Asset("SOUND", "sound/ghost.fsb"),
}

local prefabs = 
{
}

local function Retarget(inst)
    local newtarget = FindEntity(inst, 20, function(guy)
            return  guy.components.combat and 
                    inst.components.combat:CanTarget(guy) and
                    (guy.components.combat.target == GetPlayer() or GetPlayer().components.combat.target == guy)
    end)

    return newtarget
end

local function OnAttacked(inst, data)
	--print(inst, "OnAttacked")
	local attacker = data.attacker

	if attacker and attacker:HasTag("player") and GetPlayer():HasTag("paranormal") then
		inst.components.health:SetVal(0)
	else
		inst.components.combat:SetTarget(attacker)
	end
end

local function auratest(inst, target)
	if target == GetPlayer() then return false end

	local leader = inst.components.follower.leader
	if target.components.combat.target and ( target.components.combat.target == inst or target.components.combat.target == leader) then return true end
	if inst.components.combat.target == target then return true end

	if leader then
		if leader == target then return false end
		if target.components.follower and target.components.follower.leader == leader then return false end
	end

	return target:HasTag("monster") or target:HasTag("prey")
end
   

local function fn(Sim)
	
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
    local light = inst.entity:AddLight()
    inst.entity:AddPhysics()
    anim:SetBloomEffectHandle( "shaders/anim.ksh" )
    
    MakeGhostPhysics(inst, 1, .5)
    
    light:SetIntensity(.6)
    light:SetRadius(.5)
    light:SetFalloff(.6)
    light:Enable(true)
    light:SetColour(180/255, 195/255, 225/255)
	
	local brain = ""
    
	if GetPlayer():HasTag("paranormal") then
		brain = require "brains/abigailbrain"
	else 
		brain = require "brains/ghostbrain"
	end
    inst:SetBrain(brain)
    
    anim:SetBank("ghost")
    anim:SetBuild("ghost_build")
    anim:PlayAnimation("idle", true)
    --inst.AnimState:SetMultColour(1,1,1,.6)
    
    inst:AddTag("monster")
    inst:AddTag("hostile")
    inst:AddTag("ghost")
    inst:AddTag("noauradamage")

    inst:AddComponent("locomotor")
	if GetPlayer():HasTag("paranormal") then
		inst.components.locomotor.walkspeed = TUNING.GHOST_SPEED*1.5
		inst.components.locomotor.runspeed = TUNING.GHOST_SPEED*2
	else
		inst.components.locomotor.walkspeed = TUNING.GHOST_SPEED
		inst.components.locomotor.runspeed = TUNING.GHOST_SPEED
		inst.components.locomotor.directdrive = true
	end
    
	
    inst:SetStateGraph("SGghost")
	
	inst:AddComponent("sanityaura")
    inst.components.sanityaura.aura = -TUNING.SANITYAURA_MED
    
    inst:AddComponent("inspectable")
    
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(TUNING.GHOST_HEALTH)

	inst:AddComponent("combat")
    inst.components.combat.defaultdamage = TUNING.GHOST_DAMAGE
    inst.components.combat.playerdamagepercent = TUNING.GHOST_DMG_PLAYER_PERCENT

    inst:AddComponent("aura")
    inst.components.aura.radius = TUNING.GHOST_RADIUS
    inst.components.aura.tickperiod = TUNING.GHOST_DMG_PERIOD
    ------------------    
    
    inst.SoundEmitter:PlaySound("dontstarve/ghost/ghost_howl_LP", "howl")
    
	if GetPlayer():HasTag("paranormal") then
		inst:AddComponent("follower")
		local player = GetPlayer()
		if player and player.components.leader then
			player.components.leader:AddFollower(inst)
		end
	end
    
    return inst
end

return Prefab( "common/monsters/ghost", fn, assets, prefabs ) 
