local MakePlayerCharacter = require "prefabs/player_common"

local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/wilson.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),

		-- Don't forget to include your character's custom assets!
        Asset( "ANIM", "anim/norman.zip" ),
}

local prefabs = {"book_agetha"}

local start_inv = {"book_agetha"}

local function spawnAgetha(inst)
	if not inst.components.wickedwitch:agSpawn(inst) then
		return
	end
	if GetSeasonManager() and not GetSeasonManager():IsRaining() then
	
		local agPos = Point(inst.Transform:GetWorldPosition())
		agPos.x = agPos.x + math.random(-6, 6)
		agPos.z = agPos.z + math.random(-6, 6)
		
		local num_lightnings =  4
		GetPlayer():StartThread(function()
			for k = 0, num_lightnings do
				local rad = math.random(0, 1)
				local angle = k*((4*PI)/num_lightnings)
				local pos = Vector3(agPos.x, 0, agPos.z) + Vector3(rad*math.cos(angle), 0, rad*math.sin(angle))
				GetSeasonManager():DoLightningStrike(pos)
				Sleep(math.random( .3, .5))
			end
			local ag = SpawnPrefab("agetha")
			ag.Transform:SetPosition(agPos.x, 0, agPos.z)
		end)
	end
end

local fn = function(inst)
	
	-- choose which sounds this character will play
	inst.soundsname = "wilson"

	-- a minimap icon must be specified
	inst.MiniMapEntity:SetIcon( "norman.tex" )
	
	inst.components.health:SetMaxHealth(TUNING.WILSON_HEALTH * 0.8)
	inst.components.sanity:SetMax(TUNING.WILSON_SANITY * 1.2)
	inst.components.sanity.dapperness = -TUNING.DAPPERNESS_MED*1.5

	-- todo: Add an example special power here.
	
	inst:AddTag("paranormal")
	
	inst:AddComponent("reader")
	
	inst:AddComponent("wickedwitch")
	
	inst:ListenForEvent("dusktime", function() spawnAgetha(inst) end , GetWorld())
	inst:ListenForEvent("daytime", function() inst.components.wickedwitch:agDay(inst) end , GetWorld())
	
end


-- strings! Any "WOD" below would have to be replaced by the prefab name of your character.

-- First up, the character select screen lines 
-- note: these are lower-case character name
STRINGS.CHARACTER_TITLES.norman = "The Tormented Son"
STRINGS.CHARACTER_NAMES.norman = "Norman"
STRINGS.CHARACTER_DESCRIPTIONS.norman = "*No grasp on reality\n*Friendly and polite to ghosts\n*Haunted by a wicked witch"
STRINGS.CHARACTER_QUOTES.norman = "\"When people get scared, they do terrible things.\""

-- You can also add any kind of custom dialogue that you would like. Don't forget to make
-- categores that don't exist yet using = {}
-- note: these are UPPER-CASE charcacter name
STRINGS.CHARACTERS.NORMAN = require "speech_norman"

return MakePlayerCharacter("norman", prefabs, assets, fn, start_inv)
